=== system/Makefile ===
system-top: top all
all: top

DIRS = pcert
include ../Makefile-generic
include ../Makefile-subdirs

-include Makefile-deps
