=== debian/changelog ===
acl2 (6.0-2) unstable; urgency=low

  * HOME="/tmp" environment for make DOC

 -- Camm Maguire <camm@debian.org>  Sun, 13 Jan 2013 17:54:15 +0000

acl2 (6.0-1) unstable; urgency=low

  * New upstream release

 -- Camm Maguire <camm@debian.org>  Mon, 07 Jan 2013 21:45:40 +0000

acl2 (5.0-1) unstable; urgency=low

  * New upstream release
  * books retrieved separately from http://acl2-books.googlecode.com/files/books-5.0.tar.gz
  * Bug fix: "Should build-depend on emacs23 | emacs24", thanks to
    svante.signell@telia.com</a>; (Closes: #682719).

 -- Camm Maguire <camm@debian.org>  Fri, 24 Aug 2012 18:45:28 +0000
